public class Genealogie{
    private Noeud premier;
    
    public Genealogie(){
	premier=null;
    }

    public boolean estPresent(Personne p){
	Noeud cour=premier;
	while(cour!=null){
	    if(((Personne)(cour.getVal())).getSecu()==p.getSecu()){
		return true;
	    }
	    cour=cour.getSuiv();
	}
	return false;
    }
    
    //Permet de retrouver une personne  partir de son numro de scu
    public Personne recherche(int secu){
	Noeud cour=premier;
	while(cour!=null){
	    if(((Personne)(cour.getVal())).getSecu()==secu){
		return (Personne)(cour.getVal());
	    }
	    cour=cour.getSuiv();
	}
	return null;
    }

    //Affiche les personnes de s'appelant prenom nom
    public void recherche(String prenom,String nom){
	Noeud cour=premier;
	Personne p;
	while(cour!=null){
	    p=(Personne)(cour.getVal());
	    if(p.getPrenom().equals(prenom) && p.getNom().equals(nom)){
		System.out.println("  - "+p);
	    }
	    cour=cour.getSuiv();
	}
    }

    public boolean ajoute(Personne p){
	if(premier==null){
	    premier=new Noeud(p);
	    return true;
	}
	Noeud cour=premier;
	Noeud prec=cour;
	cour=cour.getSuiv();
	while(cour!=null){
	    if(((Personne)(cour.getVal())).getSecu()==p.getSecu()){
		return false;
	    }
	    prec=cour;
	    cour=cour.getSuiv();
	}
	//Ici prec correspond au noeud de la derniere personne enregistree
	prec.setSuiv(new Noeud(p));
	return true;
    }
    
    //Mariage des personnes  partir de leur numro de secu
    public void marie(Personne p1,Personne p2){
	p1.setConjoint(p2);
	p2.setConjoint(p1);
    }

    //Retourne les grands parents d'une personne 
    public Personne[] grandParents(Personne p){
        Personne[] res=new Personne[4];
	Personne tmp;
	if(p.getPere()==null){
	    res[0]=res[1]=null;
	}
	else{
	    tmp=p.getPere().getPere();
	    if(tmp==null){
		res[0]=null;
	    }
	    else{
		res[0]=tmp;
	    }
	    tmp=p.getPere().getMere();
	    if(tmp==null){
		res[1]=null;
	    }
	    else{
		res[1]=tmp;
	    }
	}
	if(p.getMere()==null){
	    res[2]=res[3]=null;
	}
	else{
	    tmp=p.getMere().getPere();
	    if(tmp==null){
		res[2]=null;
	    }
	    else{
		res[2]=tmp;
	    }
	    tmp=p.getMere().getMere();
	    if(tmp==null){
		res[3]=null;
	    }
	    else{
		res[3]=tmp;
	    }
	}
	return res;
    }

    public String afficheArbre(Personne p,int decalage){
	String str;
	if(p==null){
	    str="inconnu(e)";
	}
	else{
	    str=p.affichageConjoint()+"\n";
	    for(int i=0;i<decalage;i++){
		str+="\t";
	    }
	    str+="de pere "+afficheArbre(p.getPere(),decalage+1)+"\n";
	    for(int i=0;i<decalage;i++){
		str+="\t";
	    }
	    str+="de mere "+afficheArbre(p.getMere(),decalage+1);
	}
	return str;
    }

    public boolean memeFamille(Personne p1,Personne p2){
	if(p1==null || p2==null){
	    return false;
	}
	return p1.aPourAncetre(p2)||p1.aPourAncetre(p2.getMere())||p1.aPourAncetre(p2.getPere());
    }

    public void affiche(){
	Noeud cour=premier;
	int i=1;
	while(cour!=null){
	    System.out.println("  - "+cour.getVal());
	    cour=cour.getSuiv();
	    i++;
	}
    }
    
}