public class Personne{
    private String prenom;
    private String nom;
    private int secu;
    private boolean estHomme;
    private Personne pere;
    private Personne mere;
    private Personne conjoint;
    
    public Personne(){
	this("Toto","Dupont",0,true);
    }

    public Personne(String prenom,String nom,int secu,boolean estHomme){
	this.prenom=prenom;
	this.nom=nom;
	this.secu=secu;
	this.estHomme=estHomme;
	this.pere=null;
	this.mere=null;
	this.conjoint=null;
    }

    public String getPrenom(){
	return prenom;
    }

    public String getNom(){
	return nom;
    }

    public int getSecu(){
	return secu;
    }

    public boolean estHomme(){
	return estHomme;
    }

    public Personne getPere(){
	return pere;
    }
    
    public Personne getMere(){
	return mere;
    }

    public Personne getConjoint(){
	return conjoint;
    }

    public void setPere(Personne pere){
	this.pere=pere;
    }

    public void setMere(Personne mere){
	this.mere=mere;
    }
    
    public void setConjoint(Personne conjoint){
	this.conjoint=conjoint;
    }

    public boolean aPourAncetre(Personne p){
	if(p==null){
	    return false;
	}
	if(secu==p.getSecu()){
	    return true;
	}
	boolean res=false;
	if(pere!=null){
	    res=pere.aPourAncetre(p);
	}
	if(mere!=null){
	    res=res||mere.aPourAncetre(p);
	}
	return res;
    }

    //Affichage sans numro de secu
    public String affichageSimple(){
	String str;
	if(estHomme){
	    str="Mr ";
	}
	else if(conjoint==null){
	    str="Mlle ";
	}
	else{
	    str="Mme ";
	}
	str=str+prenom+" "+nom+" ";
	return str;
    }

    //Affichage sans numro de secu et avec conjoint
    public String affichageConjoint(){
	String str,str2="";
	if(estHomme){
	    str="Mr ";
	    if(conjoint!=null){
		str2=" epoux de "+conjoint.affichageSimple();
	    }
	}
	else if(conjoint==null){
	    str="Mlle ";
	}
	else{
	    str="Mme ";
	    str2=" epouse de "+conjoint.affichageSimple();
	}
	str=str+prenom+" "+nom+str2;
	return str;
    }


    @Override 
    public String toString(){
	String str;
	if(estHomme){
	    str="Mr ";
	}
	else if(conjoint==null){
	    str="Mlle ";
	}
	else{
	    str="Mme ";
	}
	str=str+prenom+" "+nom+" ";
	str=str+"("+Integer.toString(secu)+")";
	return str;
    }
}